<?php
/**
 * Clase Base DP para BaseCrCategoriaPrestamologDP
 *
 * @package    
 * @subpackage BaseCrCategoriaPrestamologDP
 * @author     Willy
 * @version    SVN:: BaseCrCategoriaPrestamologDP.class.php,v 1.1 2017-09-02 12:05:12 william.taype Exp $
 */
abstract class BaseCrCategoriaPrestamologDP extends CrCategoriaPrestamologBN
{
  /* Número de registros afectados */
  private $nRowsAffected;

  public function __construct($bSetDefault = true)
  {
    if( $bSetDefault instanceof CrCategoriaPrestamologBN )
    {
      $o_CrCategoriaPrestamologBN = $bSetDefault;
      if($o_CrCategoriaPrestamologBN->getIdprestamo()) : $this->setIdprestamo($o_CrCategoriaPrestamologBN->getIdprestamo()); endif;
      if($o_CrCategoriaPrestamologBN->getFecha()) : $this->setFecha($o_CrCategoriaPrestamologBN->getFecha()); endif;
      if($o_CrCategoriaPrestamologBN->getNombrecategoria()) : $this->setNombrecategoria($o_CrCategoriaPrestamologBN->getNombrecategoria()); endif;
      if($o_CrCategoriaPrestamologBN->getIdcategoria()) : $this->setIdcategoria($o_CrCategoriaPrestamologBN->getIdcategoria()); endif;
      if($o_CrCategoriaPrestamologBN->getPeso()) : $this->setPeso($o_CrCategoriaPrestamologBN->getPeso()); endif;
    }
  }

  /* Obtiene el número de registros afectados */
  public function getRowsAffected()
  {
    return $this->nRowsAffected;
  }

  public function save()
  {
    try
    {
      $con = Conexion::getConexion();
      $sql = "SELECT IF(MAX(idprestamo),(MAX(idprestamo)+1), 1) AS Maximo FROM cr_categoria_prestamolog;";
      $oLink = method_exists($con, 'getResource')?$con->getResource():$con;
      $result = mysql_query($sql, $oLink);
      $row = mysql_fetch_array($result);
      $this->setIdprestamo($row[0]);

      if($this->getIdprestamo() && $this->getFecha()){
        $a_Fields = array();

        if($this->getIdprestamo()) : $a_Fields['idprestamo'] = ($this->getIdprestamo()); endif;
        if($this->getFecha()) : $a_Fields['fecha'] = ($this->getFecha()); endif;
        if($this->getNombrecategoria()) : $a_Fields['nombrecategoria'] = ($this->getNombrecategoria()); endif;
        if($this->getIdcategoria()) : $a_Fields['idcategoria'] = ($this->getIdcategoria()); endif;
        if($this->getPeso()) : $a_Fields['peso'] = ($this->getPeso()); endif;

        $sStringField = arrayClass::implode_keys(',', $a_Fields);
        $sStringValue = "'".implode("','", $a_Fields)."'";

        $sql = "INSERT INTO cr_categoria_prestamolog (".$sStringField.") VALUES (".$sStringValue.");";
        $oLink = method_exists($con, 'getResource')?$con->getResource():$con;
        $result = mysql_query($sql, $oLink);
        if($result)
        {
          $this->nRowsAffected = (int) mysql_affected_rows($oLink);
        }
        else
        {
          throw new Exception( mysql_error($oLink) );
        }
      }
      else
      {
        throw new Exception( 'El id no esta registrado.');
      }
    }
    catch ( Exception $o_Error )
    {
      throw new Exception($o_Error->getMessage().' en '.$o_Error->getFile().' linea '.$o_Error->getLine());
    }
    return true;
  }

  public function update()
  {
    try
    {
      if($this->getIdprestamo() && $this->getFecha())
      {
        $a_Fields = array();

        if($this->getIdprestamo()) : $a_Fields['idprestamo'] = ($this->getIdprestamo()); endif;
        if($this->getFecha()) : $a_Fields['fecha'] = ($this->getFecha()); endif;
        if($this->getNombrecategoria()) : $a_Fields['nombrecategoria'] = ($this->getNombrecategoria()); endif;
        if($this->getIdcategoria()) : $a_Fields['idcategoria'] = ($this->getIdcategoria()); endif;
        if($this->getPeso()) : $a_Fields['peso'] = ($this->getPeso()); endif;

        $sStringField = arrayClass::implode_key_value(',', $a_Fields);

        $con = Conexion::getConexion();
        $sql = "UPDATE cr_categoria_prestamolog SET ".$sStringField." WHERE 1 AND idprestamo='".$this->getIdprestamo()."' AND fecha='".$this->getFecha()."';";
        $oLink = method_exists($con, 'getResource')?$con->getResource():$con;
        $result = mysql_query($sql, $oLink);
        if($result)
        {
          $this->nRowsAffected = (int) mysql_affected_rows($oLink);
        }
        else
        {
          throw new Exception( mysql_error($oLink) );
        }
      }
      else
      {
        throw new Exception( 'El id no esta registrado.');
      }
    }
    catch ( Exception $o_Error )
    {
      throw new Exception($o_Error->getMessage().' en '.$o_Error->getFile().' linea '.$o_Error->getLine());
    }
    return true;
  }

  public function delete()
  {
    try
    {
      if($this->getIdprestamo() && $this->getFecha())
      {
        $a_Fields = array();

        $con = Conexion::getConexion();
        $sql = "DELETE FROM cr_categoria_prestamolog WHERE 1 AND idprestamo='".$this->getIdprestamo()."' AND fecha='".$this->getFecha()."';"; 
        $oLink = method_exists($con, 'getResource')?$con->getResource():$con;
        $result = mysql_query($sql, $oLink);
        if($result)
        {
          $this->nRowsAffected = (int) mysql_affected_rows($oLink);
        }
        else
        {
          throw new Exception( mysql_error($oLink) );
        }
      }
      else
      {
        throw new Exception( 'El id no esta registrado.');
      }
    }
    catch ( Exception $o_Error )
    {
      throw new Exception($o_Error->getMessage().' en '.$o_Error->getFile().' linea '.$o_Error->getLine());
    }
    return true;
  }

  /* Búsqueda del registro por la llave primaria */
  public static function selectByPK($vIdprestamo, $vFecha)
  {
    try
    {
      $con = Conexion::getConexion();
      $sql = "SELECT idprestamo, fecha, nombrecategoria, idcategoria, peso FROM cr_categoria_prestamolog WHERE 1 AND idprestamo='".$vIdprestamo."' AND fecha='".$vFecha."'; ";
        $oLink = method_exists($con, 'getResource')?$con->getResource():$con;
        $result = mysql_query($sql, $oLink);
      $o_Propel = $result ? mysql_fetch_object($result) : null;
      
      return $o_Propel?self::insertObjectBN($o_Propel):null;

    }catch ( Exception $o_Error ){
      throw new Exception($o_Error->getMessage().' en '.$o_Error->getFile().' linea '.$o_Error->getLine());
    }
  }

  /* Devuelve un objeto con métodos de acceso */
  private function insertObjectBN($o_propel){
    $o_CrCategoriaPrestamologDP = new CrCategoriaPrestamologDP();
    $o_CrCategoriaPrestamologDP->setIdprestamo($o_propel->idprestamo);
    $o_CrCategoriaPrestamologDP->setFecha($o_propel->fecha);
    $o_CrCategoriaPrestamologDP->setNombrecategoria($o_propel->nombrecategoria);
    $o_CrCategoriaPrestamologDP->setIdcategoria($o_propel->idcategoria);
    $o_CrCategoriaPrestamologDP->setPeso($o_propel->peso);
    return $o_CrCategoriaPrestamologDP;
  }
}